#include "WiFiNINA.h"

void setup() {
  Serial.begin(115200);
  delay(2000);

  const char* fn = "/fs/test.bin";

  WiFiStorage.remove(fn);

  uint8_t data[3] = { 'A', 'B', 'C' };
  WiFiStorage.write(fn, 0, data, sizeof(data));

  uint32_t fsize = 0;
  if (WiFiStorage.exists(fn, &fsize)) {
    Serial.print("File exists. Size: "); Serial.println(fsize);
  }

  uint8_t result[16];
  WiFiStorage.read(fn, 0, result, fsize);

  for (int i=0; i<fsize; i++) {
    char out[4] = { 0, };
    uint8_t c = result[i];
    sprintf(out, "%02X ", c, c);
    Serial.print(out);
  }
  Serial.println();

  // Cleanup
  WiFiStorage.remove(fn);
}

void loop() {
  delay(100);
}
